
#include <stdio.h>
#include "spnhdr.h"
#include "strmhdr.h"

extern float get_float () ;

typedef float  SITE   [N_SPIN] [N_COL] [2] ;

static void get_site (site, rec)
SITE site ;
int rec [] ;
{
  site [0] [0] [0] = get_float (rec [ 0]) ;
  site [0] [0] [1] = get_float (rec [ 1]) ;
  site [0] [1] [0] = get_float (rec [ 2]) ;
  site [0] [1] [1] = get_float (rec [ 3]) ;
  site [0] [2] [0] = get_float (rec [ 4]) ;
  site [0] [2] [1] = get_float (rec [ 5]) ;
  site [1] [0] [0] = get_float (rec [ 6]) ;
  site [1] [0] [1] = get_float (rec [ 7]) ;
  site [1] [1] [0] = get_float (rec [ 8]) ;
  site [1] [1] [1] = get_float (rec [ 9]) ;
  site [1] [2] [0] = get_float (rec [10]) ;
  site [1] [2] [1] = get_float (rec [11]) ;
  site [2] [0] [0] = get_float (rec [12]) ;
  site [2] [0] [1] = get_float (rec [13]) ;
  site [2] [1] [0] = get_float (rec [14]) ;
  site [2] [1] [1] = get_float (rec [15]) ;
  site [2] [2] [0] = get_float (rec [16]) ;
  site [2] [2] [1] = get_float (rec [17]) ;
  site [3] [0] [0] = get_float (rec [18]) ;
  site [3] [0] [1] = get_float (rec [19]) ;
  site [3] [1] [0] = get_float (rec [20]) ;
  site [3] [1] [1] = get_float (rec [21]) ;
  site [3] [2] [0] = get_float (rec [22]) ;
  site [3] [2] [1] = get_float (rec [23]) ;
}

int elem (nlist, list, value)
int nlist, list [], value ;
{
  int i ;

  for (i = 0; i < nlist; i++)
    if (list [i] == value) return 1 ;
  return 0 ;
}

void print_site (data1, l_time, l_space, nsites, sites)
DATA  *data1 ;
int l_time, l_space, nsites, sites [] ;
{
  /*
      The `t' loop incorporates a bug-fix...unfortunately time
      slices have been written to the data files in the order
      1, 0, 3, 2, 5, 4,...!
  */

  int t, x ;

  for (t = 0; t < l_time; t++)
  {
    int t_slice = t ^ 1 ;
    int index   = l_space * t_slice ;

    for (x = 0; x < l_space; x++)
    {
      int *rec ;

      read_field_record (data1, (char **) &rec) ;
      if (elem (nsites, sites, index))
      {
	SITE site ;
	int s, c ;

	get_site     (site, rec) ;

	printf ("%d\n", index) ;
	for (s = 0; s < N_SPIN; s++)
	  for (c = 0; c < N_COL; c++)
	    printf ("%e  %e\n", site [s] [c] [0], site [s] [c] [1]) ;
	printf ("\n") ;
      }
      index++ ;
    }
  }
}

